// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXA = 1'000'000;

string gen_string(int len, char maxc) {
	string ret = "";
	for (int i = 0; i < len; ++i) {
		ret += rnd.next('a', maxc);
	}
	return ret;
}

vector<int> distrib(int sum, int n, int div, int bad, bool avoid_div=false) {
	vector<int> ret(n, div);
	{
		vector<int> all(n);
		iota(all.begin(), all.end(), 0);
		shuffle(all.begin(), all.end());
		all.resize(bad);
		for (int ind : all) {
			ret[ind] = rnd.next(1, div - 1);
		}
	}

	if (avoid_div) {
		fill(ret.begin(), ret.end(), div * 2);
	}

	int cur = accumulate(ret.begin(), ret.end(), 0);
	while (cur + div <= sum) {
		ret[rnd.next(n)] += div;
		cur += div;
	}

	return ret;
}


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>("n");
	int sumlenw = opt<int>("sumlenw");
	int q = opt<int>("q");
	int sumlent = opt<int>("sumlent");
	int with_mess = opt<int>("with_mess");
	char maxc = 'z';
	if (__testlib_opts.count("maxc")) {
		maxc = opt<char>("maxc");
	}
	int wrong_len = 0;
	if (__testlib_opts.count("wrong_len")) {
		wrong_len = opt<int>("wrong_len");
	}

	vector<string> arrw;
	int gcd_val;

	if (__testlib_opts.count("group1")) {
		int len = sumlenw / n;
		gcd_val = len;
		sumlenw = len * n;
		cout << n << " 1\n";
		for (int i = 0; i < n; ++i) {
			arrw.push_back(gen_string(len, maxc));
			cout << arrw[i] << "\n";
		}
		cout << len << "\n";
	} else { 
		int m;
		vector<int> arra;
		if (__testlib_opts.count("group2")) {
			arra = {1};
			gcd_val = 1;
			m = 1;
		} else {
			m = opt<int>("m");
			gcd_val = opt<int>("gcd");
			for (int i = 0; i < m - 1; ++i) {
				if (__testlib_opts.count("avoid_gcd")) {
					arra.push_back(rnd.next(2, MAXA / gcd_val) * gcd_val);
				} else {
					arra.push_back(rnd.next(1, MAXA / gcd_val) * gcd_val);
				}
			}
		}

		vector<int> w_lens = distrib(sumlenw, n, gcd_val, 0, __testlib_opts.count("avoid_gcd"));
		cout << n << " " << m << "\n";
		for (int i = 0; i < n; ++i) {
			if (__testlib_opts.count("comm_prefixes")) {
				if (i == 0) {
					arrw.push_back(gen_string(w_lens[i], maxc));
				} else {
					int prev = rnd.next(i);
					int left = rnd.next(0, min(szof(arrw[prev]), w_lens[i]));
					arrw.push_back(arrw[prev].substr(0, left) + gen_string(w_lens[i] - left, maxc));
				}
			} else if (__testlib_opts.count("period")) {
				string tmp = gen_string(gcd_val * opt<int>("period"), maxc);
				string res = "";
				for (int j = 0; j < w_lens[i]; ++j) {
					res += tmp[j % szof(tmp)];
				}
				int qwe = rnd.next(3, 10);
				for (int j = 0; j < qwe; ++j) {
					res[rnd.next((int) (szof(res) * 0.9), szof(res) - 1)] = rnd.next('a', 'z');
				}
				arrw.push_back(res);
			} else {
				arrw.push_back(gen_string(w_lens[i], maxc));
			}
		}

		shuffle(arrw.begin(), arrw.end());
		int d = 0;
		for (auto w : arrw) {
			cout << w << "\n";
			d = __gcd(d, szof(w));
		}
		for (int num : arra) {
			d = __gcd(d, num);
		}

		if (szof(arra) < m) {
			while (true) {
				int tmp;
				if (__testlib_opts.count("avoid_gcd")) {
					tmp = rnd.next(2, MAXA / gcd_val) * gcd_val;
				} else {
					tmp = rnd.next(1, MAXA / gcd_val) * gcd_val;
				}
				if (__gcd(d, tmp) == gcd_val) {
					arra.push_back(tmp);
					break;
				}
			}
		}

		shuffle(arra.begin(), arra.end());
		for (int num : arra) {
			cout << num << "\n";
		}
	}

	cout << q << "\n";
	auto lens = distrib(sumlent, q, gcd_val, wrong_len);
	vector<int> types(q - with_mess - wrong_len, 0);
	for (int i = 0; i < with_mess; ++i) {
		types.push_back(1);
	}
	shuffle(types.begin(), types.end());

	for (int i = 0; i < q; ++i) {
		int cur_len = lens[i];
		if (lens[i] % gcd_val) {
			cur_len = (cur_len + gcd_val - 1) / gcd_val * gcd_val;
		}
		string res = "";
		while (szof(res) < cur_len) {
			int ind = rnd.next(n);
			int cl;
			if (__testlib_opts.count("period")) {
				int to = min(cur_len - szof(res), szof(arrw[ind])) / gcd_val;
				cl = rnd.next(max(1, (int) (to * 0.93)), to);
			} else {
				cl = rnd.next(1, min(cur_len - szof(res), szof(arrw[ind])) / gcd_val);
			}
			res += arrw[ind].substr(0, cl * gcd_val);
		}

		res.resize(lens[i]);

		if (lens[i] % gcd_val == 0) {
			if (types.back()) {
				res[rnd.next(lens[i])] = rnd.next('a', maxc);
			}
			types.pop_back();
		}

		cout << res << "\n";
	}


	return 0;
}