#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

int main() {

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    unsigned int t;
    unsigned int n, h, q;
    cin >> t >> n >> h >> q;

    for (unsigned int test = 0; test < t; test++) {
        vector<pair<unsigned int, unsigned int>> order;
        for (unsigned int i = 0; i < n; i++) {
            cout << "? " << i + 1 << '\n';
            cout.flush();

            unsigned int cnt;
            cin >> cnt;
            if (cnt == -1) {
                return 0;
            }
            order.push_back({cnt, i});
        }

        sort(order.begin(), order.end());
        unsigned int top = order[0].second, cnt = order[0].first;
        vector<pair<unsigned int, unsigned int>> count;
        count.push_back({0, cnt});

        string s;
        unsigned long long d = 0;
        unsigned int resp;
        for (; d < h;) {
            cout << "- " << top + 1 << " 1\n";
            cout.flush();
            cin >> s;
            if (s[0] != 'O') {
                if (s[0] == '-') {
                    return 0;
                }
                break;
            }
            d++;
            if (d == h) {
                break;
            }

            cout << "? " << top + 1 << "\n";
            cout.flush();
            cin >> resp;
            if (resp == -1) {
                return 0;
            }
            if (resp > cnt) {
                count.push_back({d, resp - cnt});
            }
            cnt = resp;
        }

        unsigned long long ans = 0;
        for (auto const &p : count) {
            ans += (d - p.first) * p.second;
        }
        cout << "! " << ans << '\n';
        cout.flush();

        cin >> s;
        if (s[0] != 'O') {
            return 0;
        }
    }

}