#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

int main() {

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    unsigned int t;
    unsigned int n, h, q;
    cin >> t >> n >> h >> q;

    for (unsigned int test = 0; test < t; test++) {
        vector<pair<unsigned int, unsigned int>> order;
        for (unsigned int i = 0; i < n; i++) {
            cout << "? " << i + 1 << '\n';
            cout.flush();

            unsigned int cnt;
            cin >> cnt;
            if (cnt == -1) {
                return 0;
            }
            order.push_back({cnt, i});
        }

        sort(order.begin(), order.end());
        unsigned long long ans = 0;
        unsigned int cnt = 0;
        for (unsigned int i = 0; i < n; i++) {
            if (i == 0 || order[i].first != order[i - 1].first) {
                bool flag = true;
                cnt = 0;
                string resp;
                while (flag) {
                    cout << "- " << order[i].second + 1 << " 1\n";
                    cout.flush();
                    cin >> resp;
                    if (resp[0] == 'O') {
                        cnt++;
                        if (cnt == h) {
                            flag = false;
                        }
                    } else {
                        if (resp[0] == '-') {
                            return 0;
                        }
                        flag = false;
                    }
                }
            }
            ans += cnt;
        }

        cout << "! " << ans << '\n';
        cout.flush();

        string s;
        cin >> s;
        if (s[0] != 'O') {
            return 0;
        }
    }

}