#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

int main() {

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    unsigned int t;
    unsigned int n, h, q;
    cin >> t >> n >> h >> q;

    unsigned int step = 5;

    for (unsigned int test = 0; test < t; test++) {
        vector<pair<unsigned int, unsigned int>> order;
        for (unsigned int i = 0; i < n; i++) {
            cout << "? " << i + 1 << '\n';
            cout.flush();

            unsigned int cnt;
            cin >> cnt;
            if (cnt == -1) {
                return 0;
            }
            order.push_back({cnt, i});
        }

        sort(order.begin(), order.end());
        unsigned int top = order[0].second, cnt = order[0].first;
        vector<unsigned int> down(n);

        string s;
        unsigned int d = 0;
        unsigned int resp;
        for (; d < h;) {
            cout << "- " << top + 1 << ' ' << step << '\n';
            cout.flush();
            cin >> s;
            if (s[0] != 'O') {
                if (s[0] == '-') {
                    return 0;
                }

                bool flag = true;
                unsigned int cnt2 = 0;
                while (flag) {
                    cout << "- " << top + 1 << " 1\n";
                    cout.flush();
                    cin >> s;
                    if (s[0] == 'O') {
                        cnt2++;
                        if (cnt2 == h) {
                            flag = false;
                        }
                    } else {
                        if (s[0] == '-') {
                            return 0;
                        }
                        flag = false;
                    }
                }
                d += cnt2;
                break;
            }
            d += step;
            if (d == h) {
                break;
            }

            cout << "? " << top + 1 << "\n";
            cout.flush();
            cin >> resp;
            if (resp == -1) {
                return 0;
            }
            if (resp > cnt) {
                for (int i = resp - 1; i >= cnt; i--) {
                    down[order[i].second] = d;
                    unsigned int cnt2 = 0;
                    while (true) {
                        cout << "? " << order[i].second + 1 << '\n';
                        cout.flush();
                        cin >> resp;
                        if (resp == -1) {
                            return 0;
                        }
                        if (resp >= order[i].first) {
                            break;
                        }

                        cout << "- " << order[i].second + 1 << " 1\n";
                        cout.flush();
                        cin >> s;
                        if (s[0] == 'O') {
                            cnt2++;
                        } else {
                            if (s[0] == '-') {
                                return 0;
                            }
                            return 1;
                        }
                    }
                    down[order[i].second] -= cnt2;
                }
            }
            cnt = resp;
        }
        down[top] = 0;

        unsigned long long ans = 0;
        for (auto const &p : down) {
            ans += d - p;
        }
        cout << "! " << ans << '\n';
        cout.flush();

        cin >> s;
        if (s[0] != 'O') {
            return 0;
        }
    }

}