#include "testlib.h"
#include <unordered_set>

using namespace std;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int g = validator.group() == "" ? 4 : validator.group()[0] - '0';
    int limit = 100'000;
    if (g == 1) {
        limit = 50;
    } else if (g == 2) {
        limit = 300;
    } else if (g == 3) {
        limit = 1000;
    }

    int n = inf.readInt(1, limit, "n");
    inf.readEoln();

    unordered_set<string> a;
    for (int i = 0; i < n; i++) {
        string s = inf.readToken("[0-9]{6}", "a_i");
        ensuref(a.count(s) == 0, "token %s duplicate on position %d", s.c_str(), i);
        a.insert(s);
        inf.readEoln();
    }

    inf.readEof();
}