// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<vector<int>> arr;
	vector cnt(6, vector<int>(10));
	ll cur_inv = 0;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		arr.push_back({});
		for (int j = 0; j < 6; ++j) {
			arr[i].push_back(s[j] - '0');
			for (int d = arr[i][j] + 1; d < 10; ++d) {
				cur_inv += cnt[j][d];
			}
			cnt[j][arr[i][j]]++;
		}
	}

	ll ans = cur_inv;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < 6; ++j) {
			--cnt[j][arr[i][j]];
			for (int d = 0; d < 10; ++d) {
				if (d < arr[i][j]) {
					cur_inv -= cnt[j][d];
				}
				if (d > arr[i][j]) {
					cur_inv += cnt[j][d];
				}
			}

			++cnt[j][arr[i][j]];
		}

		ans = min(ans, cur_inv);
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}