// Checker created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;



int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	auto read_out = [&](auto& stream) {
		map<string, int> ret;
		int n = stream.readInt(0, INF);
		for (int i = 0; i < n; ++i) {
			string s = stream.readToken();
			int amount = stream.readInt();
			stream.ensuref(!ret.count(s), "hashtags in the output are not unique");
			ret[s] = amount;
		}
		return ret;
	};

	auto jans = read_out(ans);
	auto pans = read_out(ouf);

	if (pans != jans) {
		quitf(_wa, "");
	}

	quitf(_ok, "%d hashtags", szof(pans));

	return 0;
}