// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

string all = "abcdefghijklmnopqrstuvwxyz0123456789#";

string gen_string(int len, char maxc) {
	string ret = "";
	for (int i = 0; i < len; ++i) {
		if (maxc == '9') {
			ret += all[rnd.next(szof(all))];
		} else {
			int tmp = rnd.next(maxc - 'a' + 2);
			if (tmp == maxc - 'a' + 1) {
				ret += "#";
			} else {
				ret += 'a' + tmp;
			}
		}
	}
	return ret;
}

string gen_hashtag(int len, char maxc) {
	string ret = "#";
	for (int i = 1; i < len; ++i) {
		if (maxc == '9') {
			ret += all[rnd.next(szof(all) - 1)];
		} else {
			int tmp = rnd.next(maxc - 'a' + 1);
			ret += 'a' + tmp;
		}
	}
	return ret;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int minl = opt<int>("minl");
	int maxl = opt<int>("maxl");
	char maxc = '9';
	if (__testlib_opts.count("maxc")) {
		maxc = opt<string>("maxc")[0];
	}
	int len = opt<int>("len");
	int add_spaces = opt<int>("add_spaces");

	len -= add_spaces;
	vector<string> arr;
	++len;

	while (len >= 1 + minl) {
		string s;
		int cl = rnd.next(minl, min(maxl, len - 1));
		if (rnd.next(0, 1)) {
			s = gen_string(cl, maxc);
		} else {
			s = gen_hashtag(cl, maxc);
		}
		len -= szof(s) + 1;
		arr.push_back(s);
	}


	vector<int> spaces(szof(arr) + 1, 1);
	spaces.front() = spaces.back() = 0;

	for (int i = 0; i < add_spaces; ++i) {
		spaces[rnd.next(szof(spaces))]++;
	}

	for (int i = 0; i < szof(spaces); ++i) {
		cout << string(spaces[i], ' ');
		if (i < szof(spaces) - 1) {
			cout << arr[i];
		}
	}

	cout << "\n";

	return 0;
}