// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	ll n, a, b;
	cin >> n >> a >> b;
	if (a == b) {
		cout << n / 2 << "\n";
		return;
	}
	--a; --b;
	ll x = abs(a - b);
	ll y = n - x;

	ll l = -1, r = n;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		// cerr << "mid " << mid << endl;
		bool ok = false;
		ll q = mid / 3;
		vector<ll> vars = {0, x - 1, q, q + 1, x - 1 - q, x - 1 - q - 1, mid, x - 1 - mid};

		for (ll i : vars) {
			if (i < 0 || i > x - 1) {
				continue;
			}
			// cerr << i << endl;
			ll p1 = max(mid - i * 2, (mid - i) / 2);
			ll o = x - 1 - i;
			ll p2 = max(mid - o * 2, (mid - o) / 2);
			if (i > mid || o > mid) {
				continue;
			}
			if (p1 + p2 >= y - 1) {
				ok = true;
				break;
			}
		}

		if (ok) {
			r = mid;
		} else {
			l = mid;
		}
	}

	cout << r << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}