// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int MAXN = 100'000;
int MAXM = 100'000;
int MAXA = 1'000'000;
int MAXSUMLEN = 1'000'000;

int MAXQ = 100'000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	if (validator.group() == "1") {
		MAXSUMLEN = 1000;
		MAXM = 1;
	} else if (validator.group() == "2") {
		MAXSUMLEN = 1000;
		MAXM = 1;
		MAXA = 1;
	} else if (validator.group() == "3") {
		MAXSUMLEN = 1000;
	} else if (validator.group() == "4") {
		MAXSUMLEN = 100'000;
	}

	int n = inf.readInt(1, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(1, MAXM, "m");
	inf.readEoln();

	int sumlenw = 0;
	set<int> lens;
	for (int i = 0; i < n; ++i) {
		auto w = inf.readLine("[a-z]+", format("w_%d", i + 1));
		sumlenw += szof(w);
		lens.insert(szof(w));
	}

	ensure(sumlenw <= MAXSUMLEN);

	for (int i = 0; i < m; ++i) {
		int a = inf.readInt(1, MAXA, format("a_%d", i + 1));
		lens.insert(a);
		inf.readEoln();
	}

	if (validator.group() == "1") {
		ensure(szof(lens) == 1);
	}

	int q = inf.readInt(1, MAXQ, "q");
	inf.readEoln();

	int sumlent = 0;
	for (int i = 0; i < q; ++i) {
		auto t = inf.readLine("[a-z]+", format("t_%d", i + 1));
		sumlent += szof(t);
	}

	ensure(sumlent <= MAXSUMLEN);

	inf.readEof();

	return 0;
}