// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

string all = "abcdefghijklmnopqrstuvwxyz0123456789#";

string gen_string(int len, char maxc) {
	string ret = "";
	for (int i = 0; i < len; ++i) {
		if (maxc == '9') {
			ret += all[rnd.next(szof(all))];
		} else {
			int tmp = rnd.next(maxc - 'a' + 2);
			if (tmp == maxc - 'a' + 1) {
				ret += "#";
			} else {
				ret += 'a' + tmp;
			}
		}
	}
	return ret;
}

string gen_hashtag(int len, char maxc) {
	string ret = "#";
	for (int i = 1; i < len; ++i) {
		if (maxc == '9') {
			ret += all[rnd.next(szof(all) - 1)];
		} else {
			int tmp = rnd.next(maxc - 'a' + 1);
			ret += 'a' + tmp;
		}
	}
	return ret;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int minl = opt<int>("minl");
	int maxl = opt<int>("maxl");
	int q = opt<int>("q");
	int len = opt<int>("len");
	
	vector<string> hashtags;
	for (int i = 0; i < q; ++i) {
		hashtags.push_back(gen_hashtag(rnd.next(minl, maxl), 'z'));
	}

	len++;
	bool fl = false;
	while (len >= maxl + 1) {
		if (fl) {
			cout << " ";
		}
		fl = true;
		auto s =  hashtags[rnd.next(szof(hashtags))];
		cout << s;
		len -= szof(s) + 1;
	}
	cout << "\n";

	return 0;
}