#include <iostream>
#include <string>
#include <unordered_map>

using namespace std;

int main() {

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    string s;
    cin >> s;
    int n = s.size();

    unordered_map<string, int> res;
    int i = 0;
    while (i < n) {
        string r = "";
        if (s[i] == '#') {
            r += s[i];
            i++;
            while (i < n || s[i] >= 'A' && s[i] <= 'z' || s[i] >= '0' && s[i] <= '9') {
                r += s[i];
                i++;
            }
            res[r]++;
        } else {
            i++;
            continue;
        }
        i++;
        if (r.size() > 0) {
            res[r]++;
        }
    }

    cout << res.size() << '\n';
    for (auto const &t: res) {
        cout << t.first << ' ' << t.second << '\n';
    }

}