//
// Created by grifguitar on 24.03.2021
//

#include "testlib.h"

using namespace std;

typedef long long int ll;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int g = validator.group() == "" ? 5 : validator.group()[0] - '0';

    ll limit;
    if (g == 1) {
        limit = 10;
    } else if (g == 3) {
        limit = 1000;
    } else if (g == 4) {
        limit = 100000;
    } else {
        limit = 1'000'000'000'000'000'000;
    }

    ll n = inf.readLong(1LL, limit, "n");

    inf.readEoln();

    ll x = inf.readLong(1LL, n, "x") - 1;

    inf.readSpace();

    ll y = inf.readLong(1LL, n, "y") - 1;

    inf.readEoln();

    if (g == 2) {
        ensuref((x + n - 1) % n == y || x == y || (x + 1) % n == y,
                "the difference between the indices must be no more than one");
    }

    inf.readEof();
}